Compare commits

...

20 Commits

Author SHA1 Message Date
mag37
d80fba750f quickfix printfs 2025-05-12 15:54:34 +02:00
mag37
7ce523c37d added sponsor 2025-05-12 07:28:49 +02:00
mag37
8e444a688f Update rework (#178)
* first iteration rewriting the update logic

* formatting fixes

* Added an option to have compose up only target the specific container.
Used with either -F flag, config variable or label.

* Skipping update check on non-compose containers unless option is set

* Versionbump
Added new info and upped the version number.
2025-05-11 20:50:09 +02:00
mag37
ba107a424f version bump 2025-05-07 11:31:34 +02:00
op4lat
e4b5aaeb9d Enable markdown (#172) 2025-05-07 11:29:21 +02:00
mag37
f4e51121fe versionbump
info: Permission checks, now compose up on whole stack, -M markdown option added.
2025-05-03 10:20:32 +02:00
mag37
7a0eda659b Update README.md 2025-05-03 10:16:07 +02:00
mag37
77c0a4974d Update urls.list
added more
2025-05-03 09:56:21 +02:00
mag37
9d0eddbdcb rolled back
syntax error with unescaped dashes?
2025-05-03 00:20:39 +02:00
mag37
eb57b63a10 permission checks, dsm readme, markdown (#171)
* added check for docker socket permissions

* added sudo-check to pkg-manager

* corrected variable typo and some printf colors

* and newline..

* DSM extra readme added

* final tweaks, DSM readme

* added markdown to readme

* added markdown support to telegram template

* removed container specification from compose up -d
This will ensure any dependant containers in the same stack will
restart, others will be untouched.

* Rearranged where the url enrichment happens
2025-05-02 21:40:24 +02:00
Tobias Diekel
e393a781cf Add option to format releasenotes as markdown (#170)
* feat: allow markdown formatting for gotify
* feat: add option to cli args
* fix: use markdown for missing urls
* fix: do not print curl
* fix: add empty line
* bump template version

---------

Co-authored-by: Tobias Diekel <td@diekel.eu>
2025-05-02 20:08:04 +02:00
jaaviercr
af202c9d6a Update dockcheck.sh (#169)
The script did not stop when  there is an error recreating the container (in this case, docker-compose.yml was moved to other folder):
```
Now updating (1/1): nginx
latest: Pulling from library/nginx
Digest: sha256:c15da6c91de8d2f436196f3a768483ad32c258ed4e1beb3d367a27ed67253e66
Status: Image is up to date for nginx:latest
docker.io/library/nginx:latest
open /home/foo/bar/docker-compose.yml: no such file or directory

All done!
```
Added an exit for for that case.
2025-05-01 17:49:41 +02:00
Ulices
dc1673a752 fix: move new line from read to printf (#164) 2025-04-21 18:37:24 +02:00
firmlyundecided
a9e57d0737 Update urls.list (#162)
added urls for

homarr
tautulli
cleanuperr
slskd
bookstack
lubelogger
mealie
2025-04-12 11:14:07 +02:00
mag37
fff0c37fa4 Style and additions (#160)
* correcting colors

* hides progress bar in monochrome mode, added monochrome mode to config

* Added config/option to auto self-update, use with caution!

* use notification release notes url function for cli options as well

* added the flag, reordered flags

* change output order + add alpine pkgmngr

* changed logic of default.config

* added an extras section

* modifying urls list, adding option flag

* prometheus hotfix + minor tweaks

* quick pkginstaller fix

---------

Co-authored-by: Joachim Schuster <dev@joachimschuster.de>
2025-04-10 12:03:03 +02:00
mag37
0ea33366e4 prometheus hotfix 2025-04-09 18:21:07 +02:00
mag37
3a8571c625 fixes for odd unbound variables 2025-03-31 11:23:21 +02:00
mag37
710cbc118f fix: Excludes unbound 2025-03-31 07:22:22 +02:00
mag37
68ec749c39 hotfixes 2025-03-30 22:58:47 +02:00
mag37
778df1de3c PkgInstaller bug, reformatted 2025-03-30 22:17:15 +02:00
11 changed files with 298 additions and 118 deletions

View File

@@ -11,28 +11,33 @@
</p> </p>
<h2 align="center">CLI tool to automate docker image updates or notifying when updates are available.</h2> <h2 align="center">CLI tool to automate docker image updates or notifying when updates are available.</h2>
<h3 align="center">Features:</h3> <h3 align="center">selective updates, exclude containers, custom labels, notification plugins, prune when done etc.</h3>
<h3 align="center">selective updates, exclude containers, custom labels, notification plugins, prune when done and more.</h3>
<h4 align="center">For Podman - see the fork <a href="https://github.com/sudo-kraken/podcheck">sudo-kraken/podcheck</a>!</h4>
<h4 align="center">:whale: Docker Hub pull limit :chart_with_downwards_trend: not an issue for checks but for actual pulls - <a href="#whale-docker-hub-pull-limit-chart_with_downwards_trend-not-an-issue-for-checks-but-for-actual-pulls">read more</a></h4> <h4 align="center">:whale: Docker Hub pull limit :chart_with_downwards_trend: not an issue for checks but for actual pulls - <a href="#whale-docker-hub-pull-limit-chart_with_downwards_trend-not-an-issue-for-checks-but-for-actual-pulls">read more</a></h4>
<h5 align="center">For Podman - see the fork <a href="https://github.com/sudo-kraken/podcheck">sudo-kraken/podcheck</a>!</h4>
___ ___
## :bell: Changelog ## :bell: Changelog
- **v0.6.0**: Refactored a lot of code, cleaner logic and syntax, safer variables. - **v0.6.4**: Restructured the update process - first pulls all updates, then recreates all containers.
- Safer bash options with `set -euo pipefail`, `shopt -s nullglob` and `failglob`. - Added logic to skip update check on non-compose containers (unless `-r` option).
- Added a `default.conf` for user settings - persistent through updates. - Added option `-F` to revert to `compose up -d <ContainerName>` targeting specific container and not the stack.
- Added `notify_slack.sh` template for slack curl api. - Also added corresponding label and config-option.
- **v0.5.8**: Added version checks to all templates and a notification if a new template is released. - Added markdown formatting to `notify_ntfy-sh.sh` template.
- **v0.5.7**: Rewritten templates - now with a function to notify when there's a new Dockcheck release. - **v0.6.3**: Some fixes and changes:
- Manually migrate your current `notify.sh` settings to a new template for new functionality. - Stops when a container recreation (compose up -d) fails, also `up`s the whole stack now.
- **v0.5.6.1**: Async xargs hotfix - due to errors `failed to request manifest head ... context canceled` - `-M`, Markdown format url-releasenotes in notification (requires template rework, look at gotify!)
- Defaulted subprocess to 1 with `MaxAsync=1`, increase to find a stable value in your environment. - Added [addons/DSM/README.md](./addons/DSM/README.md) for more info Synology DSM info.
- Added `-x N` option to pass `MaxAsync` value at runtime. - Permission checks - graceful exit if no docker permissions + checking if root for pkg-manager.
- To disable xargs `-P` flag (max processes) all together, set `MaxAsync` to 0. - **v0.6.2**: Style and colour changes, prometheus hotfix, new options:
- **v0.5.6.0**: Heavily improved performance due to async checking for updates. - `-u`, Allow auto self update of dockcheck.sh
- `-I`, Print container release URLs in the CLI "choose update" list. (please contribute to `urls.list`)
- Extras: `-m`, Monochrome mode now hides the progress bar.
- **v0.6.1**: Hotfixes: (try removing set+shopt+shopt if debugging more errors)
- xargs/pipefail, removed `-set -e` bash option for now.
- unbound variables fixed (hopefully)
- dependency installer from pkgmanager rewritten
___ ___
@@ -42,23 +47,27 @@ ___
``` ```
$ ./dockcheck.sh -h $ ./dockcheck.sh -h
Syntax: dockcheck.sh [OPTION] [part of name to filter] Syntax: dockcheck.sh [OPTION] [part of name to filter]
Example: dockcheck.sh -y -d 10 -e nextcloud,heimdall Example: dockcheck.sh -y -x 10 -d 10 -e nextcloud,heimdall
Options: Options:
-a|y Automatic updates, without interaction. -a|y Automatic updates, without interaction.
-c D Exports metrics as prom file for the prometheus node_exporter. Provide the collector textfile directory. -c D Exports metrics as prom file for the prometheus node_exporter. Provide the collector textfile directory.
-d N Only update to new images that are N+ days old. Lists too recent with +prefix and age. 2xSlower. -d N Only update to new images that are N+ days old. Lists too recent with +prefix and age. 2xSlower.
-e X Exclude containers, separated by comma. -e X Exclude containers, separated by comma.
-f Force stack restart after update. Caution: restarts once for every updated container within stack. -f Force stop+start stack after update. Caution: restarts once for every updated container within stack.
-F Only compose up the specific container, not the whole compose stack (useful for master-compose structure).
-h Print this Help. -h Print this Help.
-i Inform - send a preconfigured notification. -i Inform - send a preconfigured notification.
-I Prints custom releasenote urls alongside each container with updates (requires urls.list).
-l Only update if label is set. See readme. -l Only update if label is set. See readme.
-m Monochrome mode, no printf color codes. -m Monochrome mode, no printf colour codes and hides progress bar.
-M Prints custom releasenote urls as markdown (requires template support).
-n No updates, only checking availability. -n No updates, only checking availability.
-p Auto-Prune dangling images after update. -p Auto-Prune dangling images after update.
-r Allow updating images for docker run, wont update the container. -r Allow updating images for docker run, wont update the container.
-s Include stopped containers in the check. (Logic: docker ps -a). -s Include stopped containers in the check. (Logic: docker ps -a).
-t N Set a timeout (in seconds) per container for registry checkups, 10 is default. -t N Set a timeout (in seconds) per container for registry checkups, 10 is default.
-u Allow automatic self updates - caution as this will pull new code and autorun it.
-v Prints current version. -v Prints current version.
-x N Set max asynchronous subprocesses, 1 default, 0 to disable, 32+ tested. -x N Set max asynchronous subprocesses, 1 default, 0 to disable, 32+ tested.
``` ```
@@ -117,9 +126,9 @@ Alternatively create an alias where specific flags and values are set.
Example `alias dc=dockcheck.sh -p -x 10 -t 3`. Example `alias dc=dockcheck.sh -p -x 10 -t 3`.
## :loudspeaker: Notifications ## :loudspeaker: Notifications
Trigger with the `-i` flag. Trigger with the `-i` flag if `notify.sh` is present and configured.
Will send a list of containers with updates available and a notification when `dockcheck.sh` itself has an update.
Run it scheduled with `-ni` to only get notified when there's updates available! Run it scheduled with `-ni` to only get notified when there's updates available!
Will also send a notification when `dockcheck.sh` itself has an update.
Use a `notify_X.sh` template file from the **notify_templates** directory, copy it to `notify.sh` alongside the script, modify it to your needs! (notify.sh is added to .gitignore) Use a `notify_X.sh` template file from the **notify_templates** directory, copy it to `notify.sh` alongside the script, modify it to your needs! (notify.sh is added to .gitignore)
**Current templates:** **Current templates:**
@@ -140,9 +149,13 @@ Use a `notify_X.sh` template file from the **notify_templates** directory, copy
Further additions are welcome - suggestions or PR! Further additions are welcome - suggestions or PR!
<sub><sup>Initiated and first contributed by [yoyoma2](https://github.com/yoyoma2).</sup></sub> <sub><sup>Initiated and first contributed by [yoyoma2](https://github.com/yoyoma2).</sup></sub>
### :date: Release notes addon to Notifications ### :date: Release notes addon
There's a function to use a lookup-file to add release note URL's to the notification message. There's a function to use a lookup-file to add release note URL's to the notification message.
Copy the notify_templates/`urls.list` file to the script directory, it will be used automatically if it's there. Modify it as necessary, the names of interest in the left column needs to match your container names. Copy the notify_templates/`urls.list` file to the script directory, it will be used automatically if it's there.
Modify it as necessary, the names of interest in the left column needs to match your container names.
To also list the URL's in the CLI output (choose containers list) use the `-I` option or variable config.
For Markdown formatting also add the `-M` option. (**this requires the template to be compatible - see gotify for example**)
The output of the notification will look something like this: The output of the notification will look something like this:
``` ```
Containers on hostname with updates available: Containers on hostname with updates available:
@@ -158,7 +171,14 @@ Pass `-x N` where N is number of subprocesses allowed, experiment in your enviro
Change the default value by editing the `MaxAsync=N` variable in `dockcheck.sh`. To disable the subprocess function set `MaxAsync=0`. Change the default value by editing the `MaxAsync=N` variable in `dockcheck.sh`. To disable the subprocess function set `MaxAsync=0`.
## :chart_with_upwards_trend: Prometheus and node_exporter ## :chart_with_upwards_trend: Extra plugins and tools:
### :small_orange_diamond: Using dockcheck.sh with the Synology DSM
If you run your container through the *Container Manager GUI* - only notifications are supported.
While if running manual (vanilla docker compose CLI) will allow you to use the update function too.
Some extra setup to tie together with Synology DSM - check out the [addons/DSM/README.md](./addons/DSM/README.md).
### :small_orange_diamond: Prometheus and node_exporter
Dockcheck can be used together with [Prometheus](https://github.com/prometheus/prometheus) and [node_exporter](https://github.com/prometheus/node_exporter) to export metrics via the file collector, scheduled with cron or likely. Dockcheck can be used together with [Prometheus](https://github.com/prometheus/prometheus) and [node_exporter](https://github.com/prometheus/node_exporter) to export metrics via the file collector, scheduled with cron or likely.
This is done with the `-c` option, like this: This is done with the `-c` option, like this:
``` ```
@@ -166,18 +186,32 @@ dockcheck.sh -c /path/to/exporter/directory
``` ```
See the [README.md](./addons/prometheus/README.md) for more detailed information on how to set it up! See the [README.md](./addons/prometheus/README.md) for more detailed information on how to set it up!
<sub><sup>Contributed by [tdralle](https://github.com/tdralle).</sup></sub> <sub><sup>Contributed by [tdralle](https://github.com/tdralle).</sup></sub>
### :small_orange_diamond: Zabbix config to monitor docker image updates
If you already use Zabbix - this config will Shows number of available docker image updates on host.
Example: *2 Docker Image updates on host-xyz*
See project: [thetorminal/zabbix-docker-image-updates](https://github.com/thetorminal/zabbix-docker-image-updates)
### :small_orange_diamond: Serve REST API to list all available updates
A custom python script to serve a REST API to get pulled into other monitoring tools like [homepage](https://github.com/gethomepage/homepage).
See [discussion here](https://github.com/mag37/dockcheck/discussions/146).
### :small_orange_diamond: Wrapper Script for Unraid's User Scripts
A custom bash wrapper script to allow the usage of dockcheck as a Unraid User Script plugin.
See [discussion here](https://github.com/mag37/dockcheck/discussions/145).
## :bookmark: Labels ## :bookmark: Labels
Optionally add labels to compose-files. Currently these are the usable labels: Optionally add labels to compose-files. Currently these are the usable labels:
``` ```
labels: labels:
mag37.dockcheck.restart-stack: true
mag37.dockcheck.update: true mag37.dockcheck.update: true
mag37.dockcheck.only-specific-container: true
mag37.dockcheck.restart-stack: true
``` ```
- `mag37.dockcheck.restart-stack: true` works instead of the `-f` option, forcing stop+restart on the whole compose-stack (Caution: Will restart on every updated container within stack).
- `mag37.dockcheck.update: true` will when used with the `-l` option only update containers with this label and skip the rest. Will still list updates as usual. - `mag37.dockcheck.update: true` will when used with the `-l` option only update containers with this label and skip the rest. Will still list updates as usual.
- `mag37.dockcheck.only-specific-container: true` works instead of the `-F` option, specifying the updated container when doing compose up, like `docker compose up -d homer`.
- `mag37.dockcheck.restart-stack: true` works instead of the `-f` option, forcing stop+restart on the whole compose-stack (Caution: Will restart on every updated container within stack).
## :roller_coaster: Workaround for non **amd64** / **arm64** ## :roller_coaster: Workaround for non **amd64** / **arm64**
`regctl` provides binaries for amd64/arm64, to use on other architecture you could try this workaround. `regctl` provides binaries for amd64/arm64, to use on other architecture you could try this workaround.
@@ -238,6 +272,7 @@ dockcheck is created and released under the [GNU GPL v3.0](https://www.gnu.org/l
- [avegy](https://github.com/avegy) - [avegy](https://github.com/avegy)
- [eichhorn](https://github.com/eichhorn) - [eichhorn](https://github.com/eichhorn)
- [stepdg](https://github.com/stepdg)
___ ___

35
addons/DSM/README.md Normal file
View File

@@ -0,0 +1,35 @@
## Using Dockcheck in DSM
Dockcheck cannot directly update containers managed in the Container Manager GUI, but it can still be used to notify you of containers with updates available. There are two ways to be notified, each with their own caveats:
1. Enabling email notifications within the Task Scheduler (_step 6i below_) will send an email that includes the entire script as run. This will not include the `urls.list` links to release notes, but it will show a full list of containers checked, up to date, and needing updates (following the args included in the scheduled task).
2. The [DSM notification template](https://github.com/mag37/dockcheck/blob/main/notify_templates/notify_DSM.sh) will enable Dockcheck to directly send an email when using the `-i` flag. This is most useful when paired with an accurate [urls.list](https://github.com/mag37/dockcheck/blob/next063/notify_templates/urls.list) file, and results in a neat succinct email notification of only containers to be updated.
This is a user preference, and both notifications are not necessary. However, regardless of the notification method, it is necessary to set up a scheduled task to run Dockcheck at a set interval (otherwise it will only run when manually triggered).
## Automate Dockcheck with DSM Task Scheduler:
1. Open Control Panel and navigate to Task Scheduler
2. Create a Scheduled Task > User-defined script
3. Task Name: Dockcheck
4. User: root
5. Schedule: _User Preference_
6. Task Settings:
1. ✔ Send run details by email (include preferred email) _This is the optional step as described above)_
2. User-defined script: `export HOME=/root && cd /path/to/dockcheck && ./dockcheck.sh -n -i -I ` _or other custom args_
8. Click OK, accept warning message
## Set up the DSM Notification template
Copy the [dockcheck/notify_templates/notify_DSM.sh](https://github.com/mag37/dockcheck/blob/main/notify_templates/notify_DSM.sh) to the same directory as where you keep `dockcheck.sh`.
Use as is (uses your default notification email setting) or edit and override manually.
![](./dsm1.png)
![](./dsm2.png)
![](./dsm3.png)
Made with much help and contribution from [@firmlyundecided](https://github.com/firmlyundecided) and [@yoyoma2](https://github.com/yoyoma2).

BIN
addons/DSM/dsm1.png Normal file

Binary file not shown.

After

Width:  |  Height:  |  Size: 16 KiB

BIN
addons/DSM/dsm2.png Normal file

Binary file not shown.

After

Width:  |  Height:  |  Size: 29 KiB

BIN
addons/DSM/dsm3.png Normal file

Binary file not shown.

After

Width:  |  Height:  |  Size: 28 KiB

View File

@@ -6,15 +6,20 @@
# This will not be replaced on updates # This will not be replaced on updates
#Timeout=10 # Set a timeout (in seconds) per container for registry checkups. #Timeout=10 # Set a timeout (in seconds) per container for registry checkups.
#MaxAsync=1 # Set max asynchronous subprocesses, 1 default, 0 to disable. #MaxAsync=10 # Set max asynchronous subprocesses, 1 default, 0 to disable.
#BarWidth=50 # The character width of the progress bar #BarWidth=50 # The character width of the progress bar
#AutoMode=true # Automatic updates, without interaction. #AutoMode=true # Automatic updates, without interaction.
#DontUpdate=true # No updates; only checking availability without interaction. #DontUpdate=true # No updates; only checking availability without interaction.
#AutoPrune=false # Auto-Prune dangling images after update. #AutoPrune=true # Auto-Prune dangling images after update.
#Notify=false # Inform - send a preconfigured notification. #AutoSelfUpdate=true # Allow automatic self updates - caution as this will pull new code and autorun it.
#Notify=true # Inform - send a preconfigured notification.
#Exclude="one,two" # Exclude containers, separated by comma. #Exclude="one,two" # Exclude containers, separated by comma.
#DaysOld="5" # Only update to new images that are N+ days old. Lists too recent with +prefix and age. 2xSlower. #DaysOld="5" # Only update to new images that are N+ days old. Lists too recent with +prefix and age. 2xSlower.
#Stopped="-a" # Include stopped containers in the check. (Logic: docker ps -a). #Stopped="-a" # Include stopped containers in the check. (Logic: docker ps -a).
#OnlyLabel=false # Only update if label is set. See readme. #OnlyLabel=true # Only update if label is set. See readme.
#ForceRestartStacks=false # Force stack restart after update. Caution. #ForceRestartStacks=true # Force stop+start stack after update. Caution: restarts once for every updated container within stack.
#DRunUp=false # Allow updating images for docker run, wont update the container. #DRunUp=true # Allow updating images for docker run, wont update the container.
#MonoMode=true # Monochrome mode, no printf colour codes and hides progress bar.
#PrintReleaseURL=true # Prints custom releasenote urls alongside each container with updates (requires urls.list)`
#PrintMarkdownURL=true # Prints custom releasenote urls as markdown
#OnlySpecific=true # Only compose up the specific container, not the whole compose. (useful for master-compose structure).

View File

@@ -1,10 +1,10 @@
#!/usr/bin/env bash #!/usr/bin/env bash
VERSION="v0.6.0" VERSION="v0.6.4"
### ChangeNotes: uservars file added. Lots of code refactoring, please report any bugs. ### ChangeNotes: Restructured update process - first pulls all images, then recreates all containers. Added -F option.
Github="https://github.com/mag37/dockcheck" Github="https://github.com/mag37/dockcheck"
RawUrl="https://raw.githubusercontent.com/mag37/dockcheck/main/dockcheck.sh" RawUrl="https://raw.githubusercontent.com/mag37/dockcheck/main/dockcheck.sh"
set -euo pipefail set -uo pipefail
shopt -s nullglob shopt -s nullglob
shopt -s failglob shopt -s failglob
@@ -27,23 +27,27 @@ fi
# Help Function # Help Function
Help() { Help() {
echo "Syntax: dockcheck.sh [OPTION] [part of name to filter]" echo "Syntax: dockcheck.sh [OPTION] [part of name to filter]"
echo "Example: dockcheck.sh -y -d 10 -e nextcloud,heimdall" echo "Example: dockcheck.sh -y -x 10 -d 10 -e nextcloud,heimdall"
echo echo
echo "Options:" echo "Options:"
echo "-a|y Automatic updates, without interaction." echo "-a|y Automatic updates, without interaction."
echo "-c Exports metrics as prom file for the prometheus node_exporter. Provide the collector textfile directory." echo "-c Exports metrics as prom file for the prometheus node_exporter. Provide the collector textfile directory."
echo "-d N Only update to new images that are N+ days old. Lists too recent with +prefix and age. 2xSlower." echo "-d N Only update to new images that are N+ days old. Lists too recent with +prefix and age. 2xSlower."
echo "-e X Exclude containers, separated by comma." echo "-e X Exclude containers, separated by comma."
echo "-f Force stack restart after update. Caution: restarts once for every updated container within stack." echo "-f Force stop+start stack after update. Caution: restarts once for every updated container within stack."
echo "-F Only compose up the specific container, not the whole compose stack (useful for master-compose structure)."
echo "-h Print this Help." echo "-h Print this Help."
echo "-i Inform - send a preconfigured notification." echo "-i Inform - send a preconfigured notification."
echo "-I Prints custom releasenote urls alongside each container with updates (requires urls.list)."
echo "-l Only update if label is set. See readme." echo "-l Only update if label is set. See readme."
echo "-m Monochrome mode, no printf colour codes." echo "-m Monochrome mode, no printf colour codes and hides progress bar."
echo "-M Prints custom releasenote urls as markdown (requires template support)."
echo "-n No updates; only checking availability without interaction." echo "-n No updates; only checking availability without interaction."
echo "-p Auto-prune dangling images after update." echo "-p Auto-prune dangling images after update."
echo "-r Allow updating images for docker run; won't update the container." echo "-r Allow updating images for docker run; won't update the container."
echo "-s Include stopped containers in the check. (Logic: docker ps -a)." echo "-s Include stopped containers in the check. (Logic: docker ps -a)."
echo "-t Set a timeout (in seconds) per container for registry checkups, 10 is default." echo "-t Set a timeout (in seconds) per container for registry checkups, 10 is default."
echo "-u Allow automatic self updates - caution as this will pull new code and autorun it."
echo "-v Prints current version." echo "-v Prints current version."
echo "-x N Set max asynchronous subprocesses, 1 default, 0 to disable, 32+ tested." echo "-x N Set max asynchronous subprocesses, 1 default, 0 to disable, 32+ tested."
echo echo
@@ -57,14 +61,20 @@ BarWidth=${BarWidth:=50}
AutoMode=${AutoMode:=false} AutoMode=${AutoMode:=false}
DontUpdate=${DontUpdate:=false} DontUpdate=${DontUpdate:=false}
AutoPrune=${AutoPrune:=false} AutoPrune=${AutoPrune:=false}
AutoSelfUpdate=${AutoSelfUpdate:=false}
OnlyLabel=${OnlyLabel:=false} OnlyLabel=${OnlyLabel:=false}
Notify=${Notify:=false} Notify=${Notify:=false}
ForceRestartStacks=${ForceRestartStacks:=false} ForceRestartStacks=${ForceRestartStacks:=false}
DRunUp=${DRunUp:=false} DRunUp=${DRunUp:=false}
MonoMode=${MonoMode:=false}
PrintReleaseURL=${PrintReleaseURL:=false}
PrintMarkdownURL=${PrintMarkdownURL:=false}
Stopped=${Stopped:=""} Stopped=${Stopped:=""}
CollectorTextFileDirectory=${CollectorTextFileDirectory:-} CollectorTextFileDirectory=${CollectorTextFileDirectory:-}
Exclude=${Exclude:-} Exclude=${Exclude:-}
DaysOld=${DaysOld:-} DaysOld=${DaysOld:-}
OnlySpecific=false
SpecificContainer=${SpecificContainer:=""}
Excludes=() Excludes=()
GotUpdates=() GotUpdates=()
NoUpdates=() NoUpdates=()
@@ -81,23 +91,27 @@ c_blue="\033[0;34m"
c_teal="\033[0;36m" c_teal="\033[0;36m"
c_reset="\033[0m" c_reset="\033[0m"
while getopts "aynpfrhlisvmc:e:d:t:x:" options; do while getopts "ayfFhiIlmMnprsuvc:e:d:t:x:" options; do
case "${options}" in case "${options}" in
a|y) AutoMode=true ;; a|y) AutoMode=true ;;
c) CollectorTextFileDirectory="${OPTARG}" ;; c) CollectorTextFileDirectory="${OPTARG}" ;;
n) DontUpdate=true; AutoMode=true;; d) DaysOld=${OPTARG} ;;
r) DRunUp=true ;;
p) AutoPrune=true ;;
l) OnlyLabel=true ;;
f) ForceRestartStacks=true ;;
i) Notify=true ;;
e) Exclude=${OPTARG} ;; e) Exclude=${OPTARG} ;;
m) declare c_{red,green,yellow,blue,teal,reset}="" ;; f) ForceRestartStacks=true ;;
F) OnlySpecific=true ;;
i) Notify=true ;;
I) PrintReleaseURL=true ;;
l) OnlyLabel=true ;;
m) MonoMode=true ;;
M) PrintMarkdownURL=true ;;
n) DontUpdate=true; AutoMode=true;;
p) AutoPrune=true ;;
r) DRunUp=true ;;
s) Stopped="-a" ;; s) Stopped="-a" ;;
t) Timeout="${OPTARG}" ;; t) Timeout="${OPTARG}" ;;
u) AutoSelfUpdate=true ;;
v) printf "%s\n" "$VERSION"; exit 0 ;; v) printf "%s\n" "$VERSION"; exit 0 ;;
x) MaxAsync=${OPTARG} ;; x) MaxAsync=${OPTARG} ;;
d) DaysOld=${OPTARG} ;;
h|*) Help; exit 2 ;; h|*) Help; exit 2 ;;
esac esac
done done
@@ -108,6 +122,7 @@ SearchName="${1:-}"
# Setting up options and sourcing functions # Setting up options and sourcing functions
if [[ "$DontUpdate" == true ]]; then AutoMode=true; fi if [[ "$DontUpdate" == true ]]; then AutoMode=true; fi
if [[ "$MonoMode" == true ]]; then declare c_{red,green,yellow,blue,teal,reset}=""; fi
if [[ "$Notify" == true ]]; then if [[ "$Notify" == true ]]; then
if [[ -s "${ScriptWorkDir}/notify.sh" ]]; then if [[ -s "${ScriptWorkDir}/notify.sh" ]]; then
source "${ScriptWorkDir}/notify.sh" source "${ScriptWorkDir}/notify.sh"
@@ -137,30 +152,30 @@ self_update_curl() {
cp "$ScriptPath" "$ScriptPath".bak cp "$ScriptPath" "$ScriptPath".bak
if command -v curl &>/dev/null; then if command -v curl &>/dev/null; then
curl -L $RawUrl > "$ScriptPath"; chmod +x "$ScriptPath" curl -L $RawUrl > "$ScriptPath"; chmod +x "$ScriptPath"
printf "\n%s\n" "--- starting over with the updated version ---" printf "\n%b---%b starting over with the updated version %b---%b\n" "$c_yellow" "$c_teal" "$c_yellow" "$c_reset"
exec "$ScriptPath" "${ScriptArgs[@]}" # run the new script with old arguments exec "$ScriptPath" "${ScriptArgs[@]}" # run the new script with old arguments
exit 1 # Exit the old instance exit 1 # Exit the old instance
elif command -v wget &>/dev/null; then elif command -v wget &>/dev/null; then
wget $RawUrl -O "$ScriptPath"; chmod +x "$ScriptPath" wget $RawUrl -O "$ScriptPath"; chmod +x "$ScriptPath"
printf "\n%s\n" "--- starting over with the updated version ---" printf "\n%b---%b starting over with the updated version %b---%b\n" "$c_yellow" "$c_teal" "$c_yellow" "$c_reset"
exec "$ScriptPath" "${ScriptArgs[@]}" # run the new script with old arguments exec "$ScriptPath" "${ScriptArgs[@]}" # run the new script with old arguments
exit 0 # exit the old instance exit 0 # exit the old instance
else else
printf "curl/wget not available - download the update manually: %s \n" "$Github" printf "\n%bcurl/wget not available %b- download the update manually: %b%s %b\n" "$c_red" "$c_reset" "$c_teal" "$Github" "$c_reset"
fi fi
} }
self_update() { self_update() {
cd "$ScriptWorkDir" || { printf "Path error, skipping update.\n"; return; } cd "$ScriptWorkDir" || { printf "%bPath error,%b skipping update.\n" "$c_red" "$c_reset"; return; }
if command -v git &>/dev/null && [[ "$(git ls-remote --get-url 2>/dev/null)" =~ .*"mag37/dockcheck".* ]]; then if command -v git &>/dev/null && [[ "$(git ls-remote --get-url 2>/dev/null)" =~ .*"mag37/dockcheck".* ]]; then
printf "\n%s\n" "Pulling the latest version." printf "\n%s\n" "Pulling the latest version."
git pull --force || { printf "Git error, manually pull/clone.\n"; return; } git pull --force || { printf "%bGit error,%b manually pull/clone.\n" "$c_red" "$c_reset"; return; }
printf "\n%s\n" "--- starting over with the updated version ---" printf "\n%s\n" "--- starting over with the updated version ---"
cd - || { printf "Path error.\n"; return; } cd - || { printf "%bPath error.%b\n" "$c_red"; return; }
exec "$ScriptPath" "${ScriptArgs[@]}" # run the new script with old arguments exec "$ScriptPath" "${ScriptArgs[@]}" # run the new script with old arguments
exit 0 # exit the old instance exit 0 # exit the old instance
else else
cd - || { printf "Path error.\n"; return; } cd - || { printf "%bPath error.%b\n" "$c_red"; return; }
self_update_curl self_update_curl
fi fi
} }
@@ -184,9 +199,6 @@ choosecontainers() {
done done
fi fi
done done
printf "\nUpdating containers:\n"
printf "%s\n" "${SelectedUpdates[@]}"
printf "\n"
} }
datecheck() { datecheck() {
@@ -218,12 +230,18 @@ progress_bar() {
# Function to add user-provided urls to releasenotes # Function to add user-provided urls to releasenotes
releasenotes() { releasenotes() {
unset Updates
for update in "${GotUpdates[@]}"; do for update in "${GotUpdates[@]}"; do
found=false found=false
while read -r container url; do while read -r container url; do
if [[ "$update" == "$container" ]]; then Updates+=("$update -> $url"); found=true; fi if [[ "$update" == "$container" ]] && [[ "$PrintMarkdownURL" == true ]]; then Updates+=("- [$update]($url)"); found=true;
elif [[ "$update" == "$container" ]]; then Updates+=("$update -> $url"); found=true;
fi
done < "${ScriptWorkDir}/urls.list" done < "${ScriptWorkDir}/urls.list"
if [[ "$found" == false ]]; then Updates+=("$update -> url missing"); else continue; fi if [[ "$found" == false ]] && [[ "$PrintMarkdownURL" == true ]]; then Updates+=("- $update -> url missing");
elif [[ "$found" == false ]]; then Updates+=("$update -> url missing");
else continue;
fi
done done
} }
@@ -239,16 +257,24 @@ binary_downloader() {
GetUrl="${BinaryUrl/TEMP/"$architecture"}" GetUrl="${BinaryUrl/TEMP/"$architecture"}"
if command -v curl &>/dev/null; then curl -L "$GetUrl" > "$ScriptWorkDir/$BinaryName"; if command -v curl &>/dev/null; then curl -L "$GetUrl" > "$ScriptWorkDir/$BinaryName";
elif command -v wget &>/dev/null; then wget "$GetUrl" -O "$ScriptWorkDir/$BinaryName"; elif command -v wget &>/dev/null; then wget "$GetUrl" -O "$ScriptWorkDir/$BinaryName";
else printf "%s\n" "curl/wget not available - get $BinaryName manually from the repo link, exiting."; exit 1; else printf "\n%bcurl/wget not available - get %s manually from the repo link, exiting.%b" "$c_red" "$BinaryName" "$c_reset"; exit 1;
fi fi
[[ -f "$ScriptWorkDir/$BinaryName" ]] && chmod +x "$ScriptWorkDir/$BinaryName" [[ -f "$ScriptWorkDir/$BinaryName" ]] && chmod +x "$ScriptWorkDir/$BinaryName"
} }
distro_checker() { distro_checker() {
if [[ -f /etc/arch-release ]]; then PkgInstaller="pacman -S" isRoot=false
elif [[ -f /etc/redhat-release ]]; then PkgInstaller="sudo dnf install" [[ ${EUID:-} == 0 ]] && isRoot=true
elif [[ -f /etc/SuSE-release ]]; then PkgInstaller="sudo zypper install" if [[ -f /etc/alpine-release ]] ; then
elif [[ -f /etc/debian_version ]]; then PkgInstaller="sudo apt-get install" [[ "$isRoot" == true ]] && PkgInstaller="apk add" || PkgInstaller="doas apk add"
elif [[ -f /etc/arch-release ]]; then
[[ "$isRoot" == true ]] && PkgInstaller="pacman -S" || PkgInstaller="sudo pacman -S"
elif [[ -f /etc/debian_version ]]; then
[[ "" == true ]] && PkgInstaller="apt-get install" || PkgInstaller="sudo apt-get install"
elif [[ -f /etc/redhat-release ]]; then
[[ "$isRoot" == true ]] && PkgInstaller="dnf install" || PkgInstaller="sudo dnf install"
elif [[ -f /etc/SuSE-release ]]; then
[[ "$isRoot" == true ]] && PkgInstaller="zypper install" || PkgInstaller="sudo zypper install"
elif [[ $(uname -s) == "Darwin" ]]; then PkgInstaller="brew install" elif [[ $(uname -s) == "Darwin" ]]; then PkgInstaller="brew install"
else PkgInstaller="ERROR"; printf "\n%bNo distribution could be determined%b, falling back to static binary.\n" "$c_yellow" "$c_reset" else PkgInstaller="ERROR"; printf "\n%bNo distribution could be determined%b, falling back to static binary.\n" "$c_yellow" "$c_reset"
fi fi
@@ -262,21 +288,25 @@ dependency_check() {
if command -v "$AppName" &>/dev/null; then export "$AppVar"="$AppName"; if command -v "$AppName" &>/dev/null; then export "$AppVar"="$AppName";
elif [[ -f "$ScriptWorkDir/$AppName" ]]; then export "$AppVar"="$ScriptWorkDir/$AppName"; elif [[ -f "$ScriptWorkDir/$AppName" ]]; then export "$AppVar"="$ScriptWorkDir/$AppName";
else else
printf "%s\n" "Required dependency '$AppName' missing, do you want to install it?" printf "\nRequired dependency %b'%s'%b missing, do you want to install it?\n" "$c_teal" "$AppName" "$c_reset"
read -r -p "y: With packagemanager (sudo). / s: Download static binary. y/s/[n] " GetBin read -r -p "y: With packagemanager (sudo). / s: Download static binary. y/s/[n] " GetBin
GetBin=${GetBin:-no} # set default to no if nothing is given GetBin=${GetBin:-no} # set default to no if nothing is given
if [[ "$GetBin" =~ [yYsS] ]]; then if [[ "$GetBin" =~ [yYsS] ]]; then
[[ "$GetBin" =~ [yY] ]] && distro_checker [[ "$GetBin" =~ [yY] ]] && distro_checker
if [[ -n "${PkgInstaller:-}" && "${PkgInstaller:-}" != "ERROR" ]]; then if [[ -n "${PkgInstaller:-}" && "${PkgInstaller:-}" != "ERROR" ]]; then
[[ $(uname -s) == "Darwin" && "$AppName" == "regctl" ]] && AppName="regclient" [[ $(uname -s) == "Darwin" && "$AppName" == "regctl" ]] && AppName="regclient"
("$PkgInstaller" "$AppName"); PkgExitcode="$?" && AppName="$1" if $PkgInstaller "$AppName"; then
if [[ "$PkgExitcode" == 0 ]]; then { export "$AppVar"="$AppName" && printf "\n%b%b installed.%b\n" "$c_green" "$AppName" "$c_reset"; } AppName="$1"
else printf "\n%bPackagemanager install failed%b, falling back to static binary.\n" "$c_yellow" "$c_reset" export "$AppVar"="$AppName"
printf "\n%b%b installed.%b\n" "$c_green" "$AppName" "$c_reset"
else
PkgInstaller="ERROR"
printf "\n%bPackagemanager install failed%b, falling back to static binary.\n" "$c_yellow" "$c_reset"
fi fi
fi fi
if [[ "$GetBin" =~ [sS] || "$PkgInstaller" == "ERROR" || "$PkgExitcode" != 0 ]]; then if [[ "$GetBin" =~ [sS] ]] || [[ "$PkgInstaller" == "ERROR" ]]; then
binary_downloader "$AppName" "$AppUrl" binary_downloader "$AppName" "$AppUrl"
[[ -f "$ScriptWorkDir/$AppName" ]] && { export "$AppVar"="$ScriptWorkDir/$1" && printf "\n%b%b downloaded.%b\n" "$c_green" "$AppName" "$c_reset"; } [[ -f "$ScriptWorkDir/$AppName" ]] && { export "$AppVar"="$ScriptWorkDir/$1" && printf "\n%b%s downloaded.%b\n" "$c_green" "$AppName" "$c_reset"; }
fi fi
else printf "\n%bDependency missing, exiting.%b\n" "$c_red" "$c_reset"; exit 1; else printf "\n%bDependency missing, exiting.%b\n" "$c_red" "$c_reset"; exit 1;
fi fi
@@ -288,10 +318,11 @@ dependency_check() {
} }
# Numbered List function # Numbered List function
options() { # if urls.list exists add release note url per line
list_options() {
num=1 num=1
for i in "${GotUpdates[@]}"; do for update in "${Updates[@]}"; do
echo "$num) $i" echo "$num) $update"
((num++)) ((num++))
done done
} }
@@ -302,6 +333,7 @@ if [[ "$VERSION" != "$LatestRelease" ]]; then
if [[ "$AutoMode" == false ]]; then if [[ "$AutoMode" == false ]]; then
read -r -p "Would you like to update? y/[n]: " SelfUpdate read -r -p "Would you like to update? y/[n]: " SelfUpdate
[[ "$SelfUpdate" =~ [yY] ]] && self_update [[ "$SelfUpdate" =~ [yY] ]] && self_update
elif [[ "$AutoMode" == true ]] && [[ "$AutoSelfUpdate" == true ]]; then self_update;
else else
[[ "$Notify" == true ]] && { [[ $(type -t dockcheck_notification) == function ]] && dockcheck_notification "$VERSION" "$LatestRelease" "$LatestChanges" || printf "Could not source notification function.\n"; } [[ "$Notify" == true ]] && { [[ $(type -t dockcheck_notification) == function ]] && dockcheck_notification "$VERSION" "$LatestRelease" "$LatestChanges" || printf "Could not source notification function.\n"; }
fi fi
@@ -311,6 +343,7 @@ dependency_check "regctl" "regbin" "https://github.com/regclient/regclient/relea
dependency_check "jq" "jqbin" "https://github.com/jqlang/jq/releases/latest/download/jq-linux-TEMP" dependency_check "jq" "jqbin" "https://github.com/jqlang/jq/releases/latest/download/jq-linux-TEMP"
# Check docker compose binary # Check docker compose binary
docker info &>/dev/null || { printf "\n%bYour current user does not have permissions to the docker socket - may require root / docker group. Exiting.%b\n" "$c_red" "$c_reset"; exit 1; }
if docker compose version &>/dev/null; then DockerBin="docker compose" ; if docker compose version &>/dev/null; then DockerBin="docker compose" ;
elif docker-compose -v &>/dev/null; then DockerBin="docker-compose" ; elif docker-compose -v &>/dev/null; then DockerBin="docker-compose" ;
elif docker -v &>/dev/null; then elif docker -v &>/dev/null; then
@@ -322,7 +355,7 @@ else
fi fi
# Listing typed exclusions # Listing typed exclusions
if [[ -n ${Excludes[*]} ]]; then if [[ -n ${Excludes[*]:-} ]]; then
printf "\n%bExcluding these names:%b\n" "$c_blue" "$c_reset" printf "\n%bExcluding these names:%b\n" "$c_blue" "$c_reset"
printf "%s\n" "${Excludes[@]}" printf "%s\n" "${Excludes[@]}"
printf "\n" printf "\n"
@@ -353,6 +386,15 @@ check_image() {
fi fi
done done
# Skipping non-compose containers unless option is set
ContLabels=$(docker inspect "$i" --format '{{json .Config.Labels}}')
ContPath=$($jqbin -r '."com.docker.compose.project.working_dir"' <<< "$ContLabels")
[[ "$ContPath" == "null" ]] && ContPath=""
if [[ -z "$ContPath" ]] && [[ "$DRunUp" == false ]]; then
printf "%s\n" "NoUpdates !$i - not checked, no compose file"
return
fi
local NoUpdates GotUpdates GotErrors local NoUpdates GotUpdates GotErrors
ImageId=$(docker inspect "$i" --format='{{.Image}}') ImageId=$(docker inspect "$i" --format='{{.Image}}')
RepoUrl=$(docker inspect "$i" --format='{{.Config.Image}}') RepoUrl=$(docker inspect "$i" --format='{{.Config.Image}}')
@@ -376,21 +418,21 @@ check_image() {
# Make required functions and variables available to subprocesses # Make required functions and variables available to subprocesses
export -f check_image datecheck export -f check_image datecheck
export Excludes_string="${Excludes[*]}" # Can only export scalar variables export Excludes_string="${Excludes[*]:-}" # Can only export scalar variables
export t_out regbin RepoUrl DaysOld export t_out regbin RepoUrl DaysOld DRunUp jqbin
# Check for POSIX xargs with -P option, fallback without async # Check for POSIX xargs with -P option, fallback without async
if (echo "test" | xargs -P 2 >/dev/null 2>&1) && [[ "$MaxAsync" != 0 ]]; then if (echo "test" | xargs -P 2 >/dev/null 2>&1) && [[ "$MaxAsync" != 0 ]]; then
XargsAsync="-P $MaxAsync" XargsAsync="-P $MaxAsync"
else else
XargsAsync="" XargsAsync=""
[[ "$MaxAsync" != 0 ]] && printf "%bMissing POSIX xargs, consider installing 'findutils' for asynchronous lookups.%b\n" "$c_red" "$c_reset" [[ "$MaxAsync" != 0 ]] && printf "%bMissing POSIX xargs, consider installing 'findutils' for asynchronous lookups.%b\n" "$c_yellow" "$c_reset"
fi fi
# Asynchronously check the image-hash of every running container VS the registry # Asynchronously check the image-hash of every running container VS the registry
while read -r line; do while read -r line; do
((RegCheckQue+=1)) ((RegCheckQue+=1))
progress_bar "$RegCheckQue" "$ContCount" if [[ "$MonoMode" == false ]]; then progress_bar "$RegCheckQue" "$ContCount"; fi
Got=${line%% *} # Extracts the first word (NoUpdates, GotUpdates, GotErrors) Got=${line%% *} # Extracts the first word (NoUpdates, GotUpdates, GotErrors)
item=${line#* } item=${line#* }
@@ -409,13 +451,13 @@ done < <( \
# Sort arrays alphabetically # Sort arrays alphabetically
IFS=$'\n' IFS=$'\n'
NoUpdates=($(sort <<<"${NoUpdates[*]}")) NoUpdates=($(sort <<<"${NoUpdates[*]:-}"))
GotUpdates=($(sort <<<"${GotUpdates[*]}")) GotUpdates=($(sort <<<"${GotUpdates[*]:-}"))
unset IFS unset IFS
# Run the prometheus exporter function # Run the prometheus exporter function
if [[ -n "${CollectorTextFileDirectory:-}" ]]; then if [[ -n "${CollectorTextFileDirectory:-}" ]]; then
if type -t send_notification &>/dev/null; then if type -t prometheus_exporter &>/dev/null; then
prometheus_exporter ${#NoUpdates[@]} ${#GotUpdates[@]} ${#GotErrors[@]} prometheus_exporter ${#NoUpdates[@]} ${#GotUpdates[@]} ${#GotErrors[@]}
else else
printf "%s\n" "Could not source prometheus exporter function." printf "%s\n" "Could not source prometheus exporter function."
@@ -426,19 +468,20 @@ fi
UpdCount="${#GotUpdates[@]}" UpdCount="${#GotUpdates[@]}"
# List what containers got updates or not # List what containers got updates or not
if [[ -n ${NoUpdates[*]} ]]; then if [[ -n ${NoUpdates[*]:-} ]]; then
printf "\n%bContainers on latest version:%b\n" "$c_green" "$c_reset" printf "\n%bContainers on latest version:%b\n" "$c_green" "$c_reset"
printf "%s\n" "${NoUpdates[@]}" printf "%s\n" "${NoUpdates[@]}"
fi fi
if [[ -n ${GotErrors[*]} ]]; then if [[ -n ${GotErrors[*]:-} ]]; then
printf "\n%bContainers with errors, won't get updated:%b\n" "$c_red" "$c_reset" printf "\n%bContainers with errors, won't get updated:%b\n" "$c_red" "$c_reset"
printf "%s\n" "${GotErrors[@]}" printf "%s\n" "${GotErrors[@]}"
printf "%binfo:%b 'unauthorized' often means not found in a public registry.\n" "$c_blue" "$c_reset" printf "%binfo:%b 'unauthorized' often means not found in a public registry.\n" "$c_blue" "$c_reset"
fi fi
if [[ -n ${GotUpdates[*]} ]]; then if [[ -n ${GotUpdates[*]:-} ]]; then
printf "\n%bContainers with updates available:%b\n" "$c_yellow" "$c_reset" printf "\n%bContainers with updates available:%b\n" "$c_yellow" "$c_reset"
[[ "$AutoMode" == false ]] && options || printf "%s\n" "${GotUpdates[@]}" if [[ -s "$ScriptWorkDir/urls.list" ]] && [[ "$PrintReleaseURL" == true ]]; then releasenotes; else Updates=("${GotUpdates[@]}"); fi
[[ "$Notify" == true ]] && { type -t send_notification &>/dev/null && send_notification "${GotUpdates[@]}" || printf "Could not source notification function.\n"; } [[ "$AutoMode" == false ]] && list_options || printf "%s\n" "${Updates[@]}"
[[ "$Notify" == true ]] && { type -t send_notification &>/dev/null && send_notification "${GotUpdates[@]}" || printf "\nCould not source notification function.\n"; }
fi fi
# Optionally get updates if there's any # Optionally get updates if there's any
@@ -450,10 +493,41 @@ if [[ -n "${GotUpdates:-}" ]]; then
SelectedUpdates=( "${GotUpdates[@]}" ) SelectedUpdates=( "${GotUpdates[@]}" )
fi fi
if [[ "$DontUpdate" == false ]]; then if [[ "$DontUpdate" == false ]]; then
printf "\n%bUpdating container(s):%b\n" "$c_blue" "$c_reset"
printf "%s\n" "${SelectedUpdates[@]}"
NumberofUpdates="${#SelectedUpdates[@]}" NumberofUpdates="${#SelectedUpdates[@]}"
CurrentQue=0 CurrentQue=0
for i in "${SelectedUpdates[@]}" for i in "${SelectedUpdates[@]}"; do
do ((CurrentQue+=1))
printf "\n%bNow updating (%s/%s): %b%s%b\n" "$c_teal" "$CurrentQue" "$NumberofUpdates" "$c_blue" "$i" "$c_reset"
ContLabels=$(docker inspect "$i" --format '{{json .Config.Labels}}')
ContImage=$(docker inspect "$i" --format='{{.Config.Image}}')
ContPath=$($jqbin -r '."com.docker.compose.project.working_dir"' <<< "$ContLabels")
[[ "$ContPath" == "null" ]] && ContPath=""
ContUpdateLabel=$($jqbin -r '."mag37.dockcheck.update"' <<< "$ContLabels")
[[ "$ContUpdateLabel" == "null" ]] && ContUpdateLabel=""
# Checking if Label Only -option is set, and if container got the label
[[ "$OnlyLabel" == true ]] && { [[ "$ContUpdateLabel" != true ]] && { echo "No update label, skipping."; continue; } }
# Checking if compose-values are empty - hence started with docker run
if [[ -z "$ContPath" ]]; then
if [[ "$DRunUp" == true ]]; then
docker pull "$ContImage"
printf "%s\n" "$i got a new image downloaded, rebuild manually with preferred 'docker run'-parameters"
else
printf "\n%b%s%b has no compose labels, probably started with docker run - %bskipping%b\n\n" "$c_yellow" "$i" "$c_reset" "$c_yellow" "$c_reset"
fi
continue
fi
docker pull "$ContImage" || { printf "\n%bDocker error, exiting!%b\n" "$c_red" "$c_reset" ; exit 1; }
done
printf "\n%bDone pulling updates. %bRecreating updated containers.%b\n" "$c_green" "$c_blue" "$c_reset"
CurrentQue=0
for i in "${SelectedUpdates[@]}"; do
((CurrentQue+=1)) ((CurrentQue+=1))
unset CompleteConfs unset CompleteConfs
# Extract labels and metadata # Extract labels and metadata
@@ -471,42 +545,37 @@ if [[ -n "${GotUpdates:-}" ]]; then
[[ "$ContUpdateLabel" == "null" ]] && ContUpdateLabel="" [[ "$ContUpdateLabel" == "null" ]] && ContUpdateLabel=""
ContRestartStack=$($jqbin -r '."mag37.dockcheck.restart-stack"' <<< "$ContLabels") ContRestartStack=$($jqbin -r '."mag37.dockcheck.restart-stack"' <<< "$ContLabels")
[[ "$ContRestartStack" == "null" ]] && ContRestartStack="" [[ "$ContRestartStack" == "null" ]] && ContRestartStack=""
ContOnlySpecific=$($jqbin -r '."mag37.dockcheck.only-specific-container"' <<< "$ContLabels")
[[ "$ContRestartStack" == "null" ]] && ContRestartStack=""
# Checking if compose-values are empty - hence started with docker run # Checking if compose-values are empty - hence started with docker run
if [[ -z "$ContPath" ]]; then [[ -z "$ContPath" ]] && continue
if [[ "$DRunUp" == true ]]; then
docker pull "$ContImage"
printf "%s\n" "$i got a new image downloaded, rebuild manually with preferred 'docker run'-parameters"
else
printf "\n%b%s%b has no compose labels, probably started with docker run - %bskipping%b\n\n" "$c_yellow" "$i" "$c_reset" "$c_yellow" "$c_reset"
fi
continue
fi
# cd to the compose-file directory to account for people who use relative volumes # cd to the compose-file directory to account for people who use relative volumes
cd "$ContPath" || { echo "Path error - skipping $i"; continue; } cd "$ContPath" || { printf "\n%bPath error - skipping%b %s" "$c_red" "$c_reset" "$i"; continue; }
## Reformatting path + multi compose ## Reformatting path + multi compose
if [[ $ContConfigFile = '/'* ]]; then if [[ $ContConfigFile = '/'* ]]; then
CompleteConfs=$(for conf in ${ContConfigFile//,/ }; do printf -- "-f %s " "$conf"; done) CompleteConfs=$(for conf in ${ContConfigFile//,/ }; do printf -- "-f %s " "$conf"; done)
else else
CompleteConfs=$(for conf in ${ContConfigFile//,/ }; do printf -- "-f %s/%s " "$ContPath" "$conf"; done) CompleteConfs=$(for conf in ${ContConfigFile//,/ }; do printf -- "-f %s/%s " "$ContPath" "$conf"; done)
fi fi
printf "\n%bNow updating (%s/%s): %b%s%b\n" "$c_teal" "$CurrentQue" "$NumberofUpdates" "$c_blue" "$i" "$c_reset"
# Checking if Label Only -option is set, and if container got the label
[[ "$OnlyLabel" == true ]] && { [[ "$ContUpdateLabel" != true ]] && { echo "No update label, skipping."; continue; } }
docker pull "$ContImage" || { printf "\n%bDocker error, exiting!%b\n" "$c_red" "$c_reset" ; exit 1; }
# Check if the container got an environment file set and reformat it # Check if the container got an environment file set and reformat it
ContEnvs="" ContEnvs=""
if [[ -n "$ContEnv" ]]; then ContEnvs=$(for env in ${ContEnv//,/ }; do printf -- "--env-file %s " "$env"; done); fi if [[ -n "$ContEnv" ]]; then ContEnvs=$(for env in ${ContEnv//,/ }; do printf -- "--env-file %s " "$env"; done); fi
# Set variable when compose up should only target the specific container, not the stack
if [[ $OnlySpecific == true ]] || [[ $ContOnlySpecific == true ]]; then SpecificContainer="$ContName"; fi
printf "\n%bNow recreating (%s/%s): %b%s%b\n" "$c_teal" "$CurrentQue" "$NumberofUpdates" "$c_blue" "$i" "$c_reset"
# Check if the whole stack should be restarted # Check if the whole stack should be restarted
if [[ "$ContRestartStack" == true ]] || [[ "$ForceRestartStacks" == true ]]; then if [[ "$ContRestartStack" == true ]] || [[ "$ForceRestartStacks" == true ]]; then
${DockerBin} ${CompleteConfs} stop; ${DockerBin} ${CompleteConfs} ${ContEnvs} up -d ${DockerBin} ${CompleteConfs} stop; ${DockerBin} ${CompleteConfs} ${ContEnvs} up -d || { printf "\n%bDocker error, exiting!%b\n" "$c_red" "$c_reset" ; exit 1; }
else else
${DockerBin} ${CompleteConfs} ${ContEnvs} up -d ${ContName} ${DockerBin} ${CompleteConfs} ${ContEnvs} up -d ${SpecificContainer} || { printf "\n%bDocker error, exiting!%b\n" "$c_red" "$c_reset" ; exit 1; }
fi fi
done done
if [[ "$AutoPrune" == false ]] && [[ "$AutoMode" == false ]]; then printf "\n"; read -rep "Would you like to prune dangling images? y/[n]: " AutoPrune; fi
if [[ "$AutoPrune" == true ]] || [[ "$AutoPrune" =~ [yY] ]]; then printf "\n Auto pruning.."; docker image prune -f; fi
printf "\n%bAll done!%b\n" "$c_green" "$c_reset" printf "\n%bAll done!%b\n" "$c_green" "$c_reset"
if [[ "$AutoPrune" == false ]] && [[ "$AutoMode" == false ]]; then read -r -p "Would you like to prune dangling images? y/[n]: " AutoPrune; fi
if [[ "$AutoPrune" == true ]] || [[ "$AutoPrune" =~ [yY] ]]; then docker image prune -f; fi
else else
printf "\nNo updates installed, exiting.\n" printf "\nNo updates installed, exiting.\n"
fi fi

View File

@@ -1,5 +1,5 @@
### DISCLAIMER: This is a third party addition to dockcheck - best effort testing. ### DISCLAIMER: This is a third party addition to dockcheck - best effort testing.
NOTIFY_GOTIFY_VERSION="v0.1" NOTIFY_GOTIFY_VERSION="v0.2"
# #
# Copy/rename this file to notify.sh to enable the notification snippet. # Copy/rename this file to notify.sh to enable the notification snippet.
# Required receiving services must already be set up. # Required receiving services must already be set up.
@@ -12,11 +12,19 @@ trigger_notification() {
GotifyToken="Your Gotify token here" GotifyToken="Your Gotify token here"
GotifyUrl="https://api.gotify/message?token=${GotifyToken}" GotifyUrl="https://api.gotify/message?token=${GotifyToken}"
curl \ if [[ "$PrintMarkdownURL" == true ]]; then
-F "title=${MessageTitle}" \ ContentType="text/markdown"
-F "message=${MessageBody}" \ else
-F "priority=5" \ ContentType="text/plain"
-X POST "${GotifyUrl}" 1> /dev/null fi
JsonData=$( jq -n \
--arg body "$MessageBody" \
--arg title "$MessageTitle" \
--arg type "$ContentType" \
'{message: $body, title: $title, priority: 5, extras: {"client::display": {"contentType": $type}}}' )
curl -s -S --data "${JsonData}" -H 'Content-Type: application/json' -X POST "${GotifyUrl}" 1> /dev/null
} }
send_notification() { send_notification() {

View File

@@ -1,5 +1,5 @@
### DISCLAIMER: This is a third party addition to dockcheck - best effort testing. ### DISCLAIMER: This is a third party addition to dockcheck - best effort testing.
NOTIFY_NTFYSH_VERSION="v0.1" NOTIFY_NTFYSH_VERSION="v0.2"
# #
# Copy/rename this file to notify.sh to enable the notification snippet. # Copy/rename this file to notify.sh to enable the notification snippet.
# Setup app and subscription at https://ntfy.sh # Setup app and subscription at https://ntfy.sh
@@ -11,10 +11,17 @@ trigger_notification() {
# Modify to fit your setup: # Modify to fit your setup:
NtfyUrl="ntfy.sh/YourUniqueTopicName" NtfyUrl="ntfy.sh/YourUniqueTopicName"
if [[ "$PrintMarkdownURL" == true ]]; then
ContentType="Markdown: yes"
else
ContentType="Markdown: no" #text/plain
fi
curl -sS -o /dev/null --show-error --fail \ curl -sS -o /dev/null --show-error --fail \
-H "Title: $MessageTitle" \ -H "Title: $MessageTitle" \
-H "$ContentType" \
-d "$MessageBody" \ -d "$MessageBody" \
$NtfyUrl "$NtfyUrl"
} }
send_notification() { send_notification() {

View File

@@ -8,6 +8,13 @@ NOTIFY_TELEGRAM_VERSION="v0.1"
FromHost=$(hostname) FromHost=$(hostname)
trigger_notification() { trigger_notification() {
if [[ "$PrintMarkdownURL" == true ]]; then
ParseMode="Markdown"
else
ParseMode="HTML"
fi
# Modify to fit your setup: # Modify to fit your setup:
TelegramToken="Your Telegram token here" TelegramToken="Your Telegram token here"
TelegramChatId="Your Telegram ChatId here" TelegramChatId="Your Telegram ChatId here"

View File

@@ -11,6 +11,12 @@ actual_server https://actualbudget.org/blog
gotify https://github.com/gotify/server/releases gotify https://github.com/gotify/server/releases
traefik https://github.com/traefik/traefik/releases traefik https://github.com/traefik/traefik/releases
caddy https://github.com/caddyserver/caddy/releases caddy https://github.com/caddyserver/caddy/releases
homarr https://github.com/homarr-labs/homarr/releases
dozzle https://github.com/amir20/dozzle/releases
beszel https://github.com/henrygd/beszel/releases
forgejo https://codeberg.org/forgejo/forgejo/releases
dockge https://github.com/louislam/dockge/releases
cup https://github.com/sergi0g/cup/releases
calibre https://github.com/linuxserver/docker-calibre/releases calibre https://github.com/linuxserver/docker-calibre/releases
calibre-web https://github.com/linuxserver/docker-calibre-web/releases calibre-web https://github.com/linuxserver/docker-calibre-web/releases
@@ -29,7 +35,15 @@ radarr https://github.com/linuxserver/docker-radarr/releases
lidarr https://github.com/linuxserver/docker-lidarr/releases lidarr https://github.com/linuxserver/docker-lidarr/releases
jellyseerr https://github.com/Fallenbagel/jellyseerr/releases jellyseerr https://github.com/Fallenbagel/jellyseerr/releases
jellyfin https://github.com/jellyfin/jellyfin/releases jellyfin https://github.com/jellyfin/jellyfin/releases
tautulli https://github.com/Tautulli/Tautulli/releases
cleanuperr https://github.com/flmorg/cleanuperr/releases
slskd https://github.com/slskd/slskd/releases
home-assistant https://github.com/home-assistant/docker/releases home-assistant https://github.com/home-assistant/docker/releases
zigbee2mqtt https://github.com/Koenkk/zigbee2mqtt/releases zigbee2mqtt https://github.com/Koenkk/zigbee2mqtt/releases
mqtt https://github.com/eclipse/mosquitto/tags mqtt https://github.com/eclipse/mosquitto/tags
bookstack https://github.com/BookStackApp/BookStack/releases
lubelogger https://github.com/hargata/lubelog/releases
mealie https://github.com/mealie-recipes/mealie/releases
flatnotes https://github.com/dullage/flatnotes/releases